package geo;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;
import java.util.ArrayList;

import org.xml.sax.SAXException;


/**
 * @author Alberto Angel 
 */
public class HTML2Text {
	
	public static void main(String args[]) throws Exception{
		System.out.println(new HTML2Text().getText(new File(args[0])));
		System.out.println(new HTML2Text().getText(new FileInputStream(new File(args[0]))));
	}
	
	public String getText(InputStream fin){
		Reader rawReader = null;
		
		try {

			BufferedInputStream bin = new BufferedInputStream(fin);
			ArrayList<Byte> predata = new ArrayList<Byte>();
			int c;
			while((c=bin.read())!=-1){
				predata.add((byte)c);
			}
			bin.close();
			byte[] data = new byte[predata.size()];
			
			c=0;
			for(Byte b : predata){
				data[c++]=b;
			}
			predata.clear();			

			//get the appropriate reader
			rawReader = CharsetDetector.getReader(data);
		
			//and parse the file into plain text
			String docString = HTMLParser.getString(rawReader);
			data = null;
			rawReader.close();
			rawReader = null;
			
			
			//now docstring contains text from html!
			return docString;
			
				
		} catch (IOException e) {
			return "";
		} catch (SAXException e) {
			return "";
		} finally {
			try {
				if (rawReader!=null){
					rawReader.close();
				}
			} catch (IOException e){
				//ignore
			}		
		}
	}
	
	public String getText(File file) {
		FileInputStream fin = null;
		Reader rawReader = null;
		
		try {

			//read file to memory
			byte [] data = new byte[(int)file.length()];
			fin = new FileInputStream(file);

			fin.read(data);
			fin.close();
			fin = null;

			//get the appropriate reader
			rawReader = CharsetDetector.getReader(data);
		
			//and parse the file into plain text
			String docString = HTMLParser.getString(rawReader);
			data = null;
			rawReader.close();
			rawReader = null;
			
			
			//now docstring contains text from html!
			return docString;
			
				
		} catch (IOException e) {
			return "";
		} catch (SAXException e) {
			return "";
		} finally {
			try {
				if (fin!=null){
					fin.close();
				}
				if (rawReader!=null){
					rawReader.close();
				}
			} catch (IOException e){
				//ignore
			}		
		}
	}
}
