package geo;

import java.util.regex.Pattern;
import java.util.regex.Matcher;
%%

%class ParsingDetector
%type String
%public
  
%function getCharset

%eofval{
  return null;
%eofval}

%unicode

%ignorecase

%{

  private static final Pattern charset = Pattern.compile("charset[^\\=]*\\=[^A-Za-z0-9\\-\\_]*([A-Za-z0-9\\-\\_]*)");
  
  private static final String doStuff(String found){
    Matcher charsetMatcher = charset.matcher(found.toLowerCase());
    charsetMatcher.find();
    return charsetMatcher.group(1);
    
  }

%}

Ws = [ \t\n\x0B\f\r\x0D\x0A\xA0\u2028\u2029\u000B\u000C\u0085]*
Alnum = [0-9A-Za-z]
//Letter = [A-Za-z]

MetaTag = \< {Ws} meta {Ws}
HttpEquiv = http {Ws} \- {Ws} equiv {Ws} \= {Ws} (\"|\')? {Ws} content \- type {Ws} (\"|\')? {Ws}
Content = content {Ws} \= {Ws} (\"|\')? {Ws} ({Alnum}|\/)+ {Ws} \; {Ws} charset {Ws} \= {Ws} ({Alnum}|\-|\_)+ {Ws} (\"|\')? {Ws}
CloseTag = \>
//OtherAttr = {Letter}+ {Ws} \= {Ws} (\"|\')? {Ws} {Alnum}+ {Ws} (\"|\')? {Ws}

%%
//<meta http-equiv="Content-Type" content="text/html; charset=utf-8">

{MetaTag} {HttpEquiv} {Content} {CloseTag} {
  return doStuff(yytext());
}

{MetaTag} {Content} {HttpEquiv} {CloseTag} {
  return doStuff(yytext());
}

//TODO: add support for other attributes

//If head ended, or body began, no meta tags may be found
\< {Ws} \/ {Ws} head {Ws} \> {
  return null;
}

\< {Ws} body {Ws} \> {
  return null;
}

{Ws}|.  { /*ignore*/ }